Attribute VB_Name = "cntSBNavale"
Option Explicit

Public TheGame      As Boolean
Public PlayGame     As Boolean
Public Position     As Boolean
Public Connection   As Boolean

Public AutoManual   As String
Public Other        As String
Public Owner        As String

Public AreaI(1 To 15, 1 To 15) As String
Public AreaII(1 To 15, 1 To 15) As String

Public Const XXX As Integer = 15
Public Const YYY As Integer = 15

Private Const CRYPT_NEWKEYSET As Long = &H8
Private Const MS_DEF_PROV As String = "Microsoft Base Cryptographic Provider v1.0"
Private Const PROV_RSA_FULL As Long = 1
Private Const ALG_CLASS_DATA_ENCRYPT As Long = 24576
Private Const ALG_CLASS_HASH As Long = 32768
Private Const ALG_TYPE_ANY As Long = 0
Private Const ALG_TYPE_BLOCK As Long = 1536
Private Const ALG_TYPE_STREAM As Long = 2048
Private Const ALG_SID_RC2 As Long = 2
Private Const ALG_SID_RC4 As Long = 1
Private Const ALG_SID_MD5 As Long = 3
Private Const CALG_MD5 As Long = ((ALG_CLASS_HASH Or ALG_TYPE_ANY) Or ALG_SID_MD5)
Private Const CALG_RC2 As Long = ((ALG_CLASS_DATA_ENCRYPT Or ALG_TYPE_BLOCK) Or ALG_SID_RC2)
Private Const CALG_RC4 As Long = ((ALG_CLASS_DATA_ENCRYPT Or ALG_TYPE_STREAM) Or ALG_SID_RC4)
Private Const ENCRYPT_ALGORITHM As Long = CALG_RC4
Private Const ENCRYPT_BLOCK_SIZE As Long = 1
Private Const CRYPT_EXPORTABLE As Long = 1

Private Declare Function CryptAcquireContext Lib "Advapi32.dll" Alias "CryptAcquireContextA" (phProv As Long, ByVal pszContainer As Long, ByVal pszProvider As String, ByVal dwProvType As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptCreateHash Lib "Advapi32.dll" (ByVal hProv As Long, ByVal Algid As Long, ByVal hKey As Long, ByVal dwFlags As Long, phHash As Long) As Long
Private Declare Function CryptHashData Lib "Advapi32.dll" (ByVal hHash As Long, ByVal pbData As String, ByVal dwDataLen As Long, ByVal dwFlags As Long) As Long
Private Declare Function CryptDeriveKey Lib "Advapi32.dll" (ByVal hProv As Long, ByVal Algid As Long, ByVal hBaseData As Long, ByVal dwFlags As Long, phKey As Long) As Long
Private Declare Function CryptDestroyHash Lib "Advapi32.dll" (ByVal hHash As Long) As Long
Private Declare Function CryptDestroyKey Lib "Advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function CryptEncrypt Lib "Advapi32.dll" (ByVal hKey As Long, ByVal hHash As Long, ByVal Final As Long, ByVal dwFlags As Long, ByVal pbData As String, pdwDataLen As Long, ByVal dwBufLen As Long) As Long
Private Declare Function CryptDecrypt Lib "Advapi32.dll" (ByVal hKey As Long, ByVal hHash As Long, ByVal Final As Long, ByVal dwFlags As Long, ByVal pbData As String, pdwDataLen As Long) As Long
Private Declare Function CryptReleaseContext Lib "Advapi32.dll" (ByVal hProv As Long, ByVal dwFlags As Long) As Long

Private Const MAX_WSADescription As Long = 256
Private Const MAX_WSASYSStatus As Long = 128
Private Const ERROR_SUCCESS As Long = 0
Private Const WS_VERSION_REQD As Long = &H101
Private Const WS_VERSION_MAJOR As Long = WS_VERSION_REQD \ &H100 And &HFF&
Private Const WS_VERSION_MINOR As Long = WS_VERSION_REQD And &HFF&
Private Const MIN_SOCKETS_REQD As Long = 1
Private Const SOCKET_ERROR As Long = -1

Private Declare Function WSAGetLastError Lib "WSOCK32.DLL" () As Long
Private Declare Function WSAStartup Lib "WSOCK32.DLL" (ByVal wVersionRequired As Long, lpWSADATA As WSADATA) As Long
Private Declare Function WSACleanup Lib "WSOCK32.DLL" () As Long
Private Declare Function GetHostName Lib "WSOCK32.DLL" Alias "gethostname" (ByVal szHost As String, ByVal dwHostLen As Long) As Long
Private Declare Function GetHostByName Lib "WSOCK32.DLL" Alias "gethostbyname" (ByVal szHost As String) As Long

Private Declare Sub CopyMemory Lib "Kernel32.dll" Alias "RtlMoveMemory" (hpvDest As Any, ByVal hpvSource As Long, ByVal cbCopy As Long)

Private Type HOSTENT
   hName      As Long
   hAliases   As Long
   hAddrType  As Integer
   hLen       As Integer
   hAddrList  As Long
End Type

Private Type WSADATA
   wVersion      As Integer
   wHighVersion  As Integer
   szDescription(0 To MAX_WSADescription) As Byte
   szSystemStatus(0 To MAX_WSASYSStatus) As Byte
   wMaxSockets   As Integer
   wMaxUDPDG     As Integer
   dwVendorInfo  As Long
End Type
Public Function Decrypt(ByVal InputBuffer As String, ByVal EncryptionKey As String, Optional ByVal UUEncoded As Boolean = False) As String
   Dim lHExchgKey As Long, lHCryptprov As Long, lHHash As Long, lHkey As Long, lResult As Long, lCryptBufLen As Long, lCryptPoint As Long, lPasswordPoint As Long, lPasswordCount As Long
   Dim sProvider As String
   Dim sCryptBuffer As String
   '
   'Decripta il testo specificato.
   On Error Resume Next
   '
   If InputBuffer = "" Then Exit Function
   '
   If UUEncoded Then
      InputBuffer = UUDecode(InputBuffer)
   End If
   sProvider = vbNullChar
   sProvider = MS_DEF_PROV & vbNullChar
   If CryptAcquireContext(lHCryptprov, 0&, sProvider, PROV_RSA_FULL, 0) Then
      If CryptCreateHash(lHCryptprov, CALG_MD5, 0, 0, lHHash) Then
         If CryptHashData(lHHash, EncryptionKey, Len(EncryptionKey), 0) Then
            If CryptDeriveKey(lHCryptprov, ENCRYPT_ALGORITHM, lHHash, 0, lHkey) Then
               CryptDestroyHash (lHHash)
               lHHash = 0
               lCryptBufLen = Len(InputBuffer) * 2
               sCryptBuffer = String(lCryptBufLen, vbNullChar)
               LSet sCryptBuffer = InputBuffer
               If CryptDecrypt(lHkey, 0, 1, 0, sCryptBuffer, lCryptBufLen) Then
                  Decrypt = Mid$(sCryptBuffer, 1, lCryptBufLen / 2)
               End If
            End If
         End If
      End If
   End If
   '
   If Err.LastDllError Then Err = Err.LastDllError
   If (lHkey) Then lResult = CryptDestroyKey(lHkey)
   If lHExchgKey Then CryptDestroyKey (lHExchgKey)
   If lHHash Then CryptDestroyHash (lHHash)
   If lHCryptprov Then lResult = CryptReleaseContext(lHCryptprov, 0)
   If Err Then Err.Raise Err, "Low Crypt API (Decrypt)"
End Function
Public Function Encrypt(ByVal InputBuffer As String, ByVal EncryptionKey As String, Optional ByVal UseUUEncoding As Boolean = False) As String
   Dim lHHash As Long, lHkey As Long, lResult As Long, lHExchgKey As Long, lHCryptprov As Long, lCryptLength As Long, lCryptBufLen As Long
   Dim sContainer As String, sCryptBuffer As String, sProvider As String
   Dim lngRet As Long
   '
   'Cripta il testo specificato.
   On Error Resume Next
   '
   If InputBuffer = "" Then Exit Function
   '
   sProvider = MS_DEF_PROV & vbNullChar
   lngRet = CryptAcquireContext(lHCryptprov, 0&, sProvider, PROV_RSA_FULL, 0)
   '
   If lngRet = 0 Then
      lngRet = CryptAcquireContext(lHCryptprov, 0&, sProvider, PROV_RSA_FULL, CRYPT_NEWKEYSET)
   End If
   If lngRet Then
      If CryptCreateHash(lHCryptprov, CALG_MD5, 0, 0, lHHash) Then
         If CryptHashData(lHHash, EncryptionKey, Len(EncryptionKey), 0) Then
            If CryptDeriveKey(lHCryptprov, ENCRYPT_ALGORITHM, lHHash, 0, lHkey) Then
               CryptDestroyHash (lHHash)
               lHHash = 0
               lCryptLength = Len(InputBuffer)
               lCryptBufLen = lCryptLength * 2
               sCryptBuffer = String(lCryptBufLen, vbNullChar)
               LSet sCryptBuffer = InputBuffer
               If CryptEncrypt(lHkey, 0, 1, 0, sCryptBuffer, lCryptLength, lCryptBufLen) Then
                   sCryptBuffer = Mid$(sCryptBuffer, 1, lCryptLength)
                   If UseUUEncoding Then
                       sCryptBuffer = UUEncode(sCryptBuffer)
                   End If
                   Encrypt = sCryptBuffer
               End If
            End If
         End If
      End If
   End If
   '
   If Err.LastDllError Then Err = Err.LastDllError
   '
   If lHkey Then lResult = CryptDestroyKey(lHkey)
   If lHExchgKey Then CryptDestroyKey (lHExchgKey)
   If lHHash Then CryptDestroyHash (lHHash)
   If lHCryptprov Then lResult = CryptReleaseContext(lHCryptprov, 0)
   If Err Then Err.Raise Err, "Low Crypt API (Encrypt)"
End Function
Public Function GetIPAddress() As String
   Dim sHostName As String * 256
   Dim lpHost As Long
   Dim HOST As HOSTENT
   Dim dwIPAddr As Long
   Dim tmpIPAddr() As Byte
   Dim i As Integer
   Dim sIPAddr  As String
   If Not SocketsInitialize() Then
      GetIPAddress = ""
      Exit Function
   End If
   '"GetHostName" returns the name of the local host into
   'the buffer specified by the name parameter. The host
   'name is returned as a null-terminated string. The
   'form of the host name is dependent on the Windows
   'Sockets provider - it can be a simple host name, or
   'it can be a fully qualified domain name. However, it
   'is guaranteed that the name returned will be successfully
   'parsed by gethostbyname and WSAAsyncGetHostByName.
   '-----------
   'In actual application, if no local host name has been
   'configured, gethostname must succeed and return a token
   'host name that "GetHostByName" or "WSAAsyncGetHostByName"
   'can resolve.
   If GetHostName(sHostName, 256) = SOCKET_ERROR Then
      GetIPAddress = ""
      MsgBox "Errore della Socket di Windows numero " & Str$(WSAGetLastError()) & ". Impossibile recuperare il nome dell'host.", vbOKOnly + vbSystemModal + vbExclamation, "LowCrypt.dll"
      SocketsCleanup
      Exit Function
   End If
   '"GetHostByName" returns a pointer to a HOSTENT structure
   '- a structure allocated by Windows Sockets. The HOSTENT
   'structure contains the results of a successful search
   'for the host specified in the name parameter.
   '-----------
   'The application must never attempt to modify this
   'structure or to free any of its components. Furthermore,
   'only one copy of this structure is allocated per thread,
   'so the application should copy any information it needs
   'before issuing any other Windows Sockets function calls.
   '-----------
   '"GetHostByName" function cannot resolve IP address strings
   'passed to it. Such a request is treated exactly as if an
   'unknown host name were passed. Use inet_addr to convert
   'an IP address string the string to an actual IP address,
   'then use another function, gethostbyaddr, to obtain the
   'contents of the HOSTENT structure.
   sHostName = Trim$(sHostName)
   lpHost = GetHostByName(sHostName)
   If lpHost = 0 Then
      GetIPAddress = ""
      MsgBox "Errore della Socket di Windows. Impossibile recuperare il nome dell'host.", vbOKOnly + vbSystemModal + vbExclamation, "LowCrypt.dll"
      SocketsCleanup
      Exit Function
   End If
   'To extract the returned IP address, we have to copy
   'the HOST structure and its members.
   CopyMemory HOST, lpHost, Len(HOST)
   CopyMemory dwIPAddr, HOST.hAddrList, 4
   'Create an array to hold the result.
   ReDim tmpIPAddr(1 To HOST.hLen)
   CopyMemory tmpIPAddr(1), dwIPAddr, HOST.hLen
   'With the array, build the actual address,
   'appending a period between members.
   For i = 1 To HOST.hLen
       sIPAddr = sIPAddr & tmpIPAddr(i) & "."
   Next i
   'The routine adds a period to the end of the
   'string, so remove it here.
   GetIPAddress = Mid$(sIPAddr, 1, Len(sIPAddr) - 1)
   SocketsCleanup
End Function
Public Function GetIPHostName() As String
   Dim sHostName As String * 256
   If Not SocketsInitialize() Then
      GetIPHostName = ""
      Exit Function
   End If
   If GetHostName(sHostName, 256) = SOCKET_ERROR Then
      GetIPHostName = ""
      MsgBox "Errore della Socket di Windows numero " & Str$(WSAGetLastError()) & ". Impossibile recuperare il nome dell'host.", vbOKOnly + vbSystemModal + vbExclamation, "LowCrypt.dll"
      SocketsCleanup
      Exit Function
   End If
   GetIPHostName = Left$(sHostName, InStr(sHostName, Chr(0)) - 1)
   SocketsCleanup
End Function

Private Sub SocketsCleanup()
   If WSACleanup() <> ERROR_SUCCESS Then
      MsgBox "Errore imprevisto della Socket.", vbOKOnly + vbSystemModal + vbExclamation, "LowCrypt.dll"
   End If
End Sub
Private Function SocketsInitialize() As Boolean
   Dim WSAD As WSADATA
   Dim sLoByte As String
   Dim sHiByte As String
   If WSAStartup(WS_VERSION_REQD, WSAD) <> ERROR_SUCCESS Then
      MsgBox "La Socket di Windows a 32 bit non risponde correttamente.", vbOKOnly + vbSystemModal + vbExclamation, "LowCrypt.dll"
      SocketsInitialize = False
      Exit Function
   End If
   If WSAD.wMaxSockets < MIN_SOCKETS_REQD Then
      MsgBox "Questa applicazione richiede almeno " & CStr(MIN_SOCKETS_REQD) & " sockets supportati.", vbOKOnly + vbSystemModal + vbExclamation, "LowCrypt.dll"
      SocketsInitialize = False
      Exit Function
   End If
   If LoByte(WSAD.wVersion) < WS_VERSION_MAJOR Or (LoByte(WSAD.wVersion) = WS_VERSION_MAJOR And HiByte(WSAD.wVersion) < WS_VERSION_MINOR) Then
      sHiByte = CStr(HiByte(WSAD.wVersion))
      sLoByte = CStr(LoByte(WSAD.wVersion))
      MsgBox "La versione della Socket " & sLoByte & "." & sHiByte & " non  supportata dal Socket di Windows a 32 bit.", vbOKOnly + vbSystemModal + vbExclamation, "LowCrypt.dll"
      SocketsInitialize = False
      Exit Function
   End If
   SocketsInitialize = True
End Function
Private Function UUDecode(ByVal InputBuffer As String) As String
   Dim bytChar()    As Byte
   Dim intLen       As Integer
   Dim intFill      As Integer
   Dim strOutBuffer As String
   '
   On Error Resume Next
   '
   intLen = 1
   intFill = Len(InputBuffer) Mod 4
   InputBuffer = InputBuffer & String(intFill, "`")
   Do While intLen <= Len(InputBuffer)
      bytChar = StrConv(Mid(InputBuffer, intLen, 4), vbFromUnicode)
      ReDim Preserve bytChar(3)
      strOutBuffer = strOutBuffer & Chr(((((bytChar(0) - 32) And 63) * 4) Or Int(((bytChar(1) - 32) And 63) / 16)) And &HFF)
      strOutBuffer = strOutBuffer & Chr(((((bytChar(1) - 32) And 63) * 16) Or Int(((bytChar(2) - 32) And 63) / 4)) And &HFF)
      strOutBuffer = strOutBuffer & Chr(((((bytChar(2) - 32) And 63) * 64) Or ((bytChar(3) - 32) And 63)) And &HFF)
      intLen = intLen + 4
   Loop
   '
   Select Case intFill
       Case Is = 1
           UUDecode = Left(strOutBuffer, Len(strOutBuffer) - intFill)
       Case Is = 2
           UUDecode = Left(strOutBuffer, Len(strOutBuffer) - intFill)
       Case Is = 3
           UUDecode = Left(strOutBuffer, Len(strOutBuffer) - intFill - 1)
       Case Else
           UUDecode = strOutBuffer
   End Select
   '
   Err.Clear
End Function
Private Function UUEncode(ByVal InputBuffer As String) As String
   Dim bytChar()    As Byte
   Dim bytBuffer()  As Byte
   Dim intStrPos    As Integer
   Dim strOutBuffer As String
   '
   On Error Resume Next
   '
   For intStrPos = 1 To Len(InputBuffer) Step 3
       bytBuffer = StrConv(Mid(InputBuffer, intStrPos, 3), vbFromUnicode)
       ReDim Preserve bytChar(IIf(UBound(bytBuffer) = 3, 3, UBound(bytBuffer) + 1))
       If UBound(bytBuffer) < 3 Then ReDim Preserve bytBuffer(UBound(bytBuffer) + 1)
       bytChar(0) = Int(bytBuffer(0) / 4)
       bytChar(0) = IIf(bytChar(0), (bytChar(0) And 63) + 32, 96)
       bytChar(1) = ((bytBuffer(0) * 16) And 48) Or (Int(bytBuffer(1) / 16) And 15)
       bytChar(1) = IIf(bytChar(1), (bytChar(1) And 63) + 32, 96)
       bytChar(2) = ((bytBuffer(1) * 4) And 60) Or (Int(bytBuffer(2) / 64) And 3)
       bytChar(2) = IIf(bytChar(2), (bytChar(2) And 63) + 32, 96)
       bytChar(3) = (bytBuffer(2) And 63)
       bytChar(3) = IIf(bytChar(3), (bytChar(3) And 63) + 32, 96)
       strOutBuffer = strOutBuffer & StrConv(bytChar, vbUnicode)
   Next intStrPos
   '
   UUEncode = strOutBuffer
   '
   Err.Clear
End Function

Private Function HiByte(ByVal wParam As Integer) As Integer
    Dim tmp As Integer
    tmp = wParam \ &H100
    HiByte = tmp And &HFF&
End Function

Private Function LoByte(ByVal wParam As Integer) As Integer
    LoByte = wParam And &HFF&
End Function

